{ DEFINE Debug}
{$A+,B-,F+,G+,E-,N-,P+,T-,V-,X+}
{$IFDEF Debug}
  {$D+,L+,Y+,I+,Q-,R+,S+}
{$ELSE}
  {$D-,L-,Y-,I-,Q-,R-,S-}
{$ENDIF}

{{$A+,B-,D+,E-,F+,I-,L+,O-,N-,P+,Q-,R-,S-,T-,V-,X+}

{ Copyright (C) 1995-96 By The GodFather }

UNIT GMenus;



INTERFACE



USES GUtils;



CONST
  NormalLineAttr  = 1;
  NormalLineHiAttr= 2;
  NormalAttr      = 3;
  NormHiAttr      = 4;
  HiMenuBar       = 5;
  HiCMenuBar      = 6;
  DisNormAttr     = 7;
  DisHiAttr       = 8;
  BoxAttr         = 9;

  cmLeft          = -100;
  cmRight         = -101;
  cmQuit          = -127;

VAR
  MenuBorder   : FrameStyle;
  MenuPallette : ARRAY[1..9] OF Byte;
  MenuDispacher: PROCEDURE(Main, Sub: Byte);
  HelpProcedure: PROCEDURE(Main, Sub: Byte);


PROCEDURE NewSubMenu(AName: STRING; AKeyCode: Word);
PROCEDURE NewItem(AName: STRING; AParam: STRING; AHotKey: Word);
PROCEDURE NewLine;

PROCEDURE DrawMenuBar;

PROCEDURE DisposeMenu;

PROCEDURE ModifyItemDisabled(Main,Sub: Byte; ADisabled: Boolean);
PROCEDURE ModifyItemParam(Main,Sub: Byte; NewParam: STRING);

PROCEDURE MenuHandle(VAR Key: Word);


IMPLEMENTATION


TYPE
  PString   = ^STRING;  { My own PSTRING type. NOT from OBJECTS.TPU }

  PMenuItem = ^TMenuItem;
  TMenuItem = RECORD
    Name    : PString;
    Param   : PString;
    Disabled: Boolean;
    KeyCode : Word;
    HiChar  : Char;
    HiPos   : Byte;
  END;

  PMenu = ^TMenu;
  TMenu = RECORD
    Name     : PString;
    WinXPos  : Byte;
    MenuXPos : Byte;
    Default  : Byte;
    KeyCode  : Word;
    ItemCount: Byte;
    MenuWidth: Byte;
    ItemData : ARRAY[1..24] OF PMenuItem;
  END;

VAR
  Menu      : ARRAY[1..15] OF PMenu;
  MenuX     : Byte;
  MenuCount : Byte;
  LastOpened: Byte;

{- PString ROUTINES ----------------------------------------------}
FUNCTION NewStr(St: STRING):PString;
VAR P: PString; SLength: Byte;
BEGIN
  SLength := Length(St);
  GetMem(P,SLength+1);
  P^      := St;
  NewStr  := P;
END;

PROCEDURE DisposeStr(VAR P: PString);
BEGIN
  FreeMem(P,Ord(P^[0]));
END;
{-----------------------------------------------------------------}

{-----------------------------------------------------------------}
PROCEDURE NewSubMenu(AName: STRING; AKeyCode: Word);
BEGIN
  Inc(MenuCount);
  New(Menu[MenuCount]);
  IF MenuCount = 1 THEN MenuX := 3;
  WITH Menu[MenuCount]^ DO
  BEGIN
    Name      := NewStr(AName);
    MenuXPos  := MenuX;
    WinXPos   := MenuX;
    KeyCode   := AKeyCode;
    Default   := 1;
    ItemCount := 0;
    MenuWidth := 0;
    Inc(MenuX,Length(AName)+2);
  END;
END;

PROCEDURE NewItem(AName: STRING; AParam: STRING; AHotKey: Word);
VAR Len,Add: ShortInt;
BEGIN
  Inc(Menu[MenuCount]^.ItemCount);
  WITH Menu[MenuCount]^ DO
  BEGIN
    Len := Pred(Length(AName))+Length(AParam)+1;
    IF Length(AParam) = 0 THEN Dec(Len,2);

    IF Len > MenuWidth THEN
    BEGIN
      MenuWidth := Len;
      IF (WinXPos+MenuWidth+4) > MaxX THEN WinXPos := MaxX-MenuWidth-5;
    END;

    New(ItemData[ItemCount]);
    WITH ItemData[ItemCount]^ DO
    BEGIN
      IF AParam = ''
        THEN Param := NIL
        ELSE Param := NewStr(AParam);
      Disabled := False;
      KeyCode := AHotKey;
      HiChar := AName[Pos('~',AName)+1];
      HiPos := Pos('~',AName);
      Delete(AName,HiPos,1);
      Name := NewStr(AName);
    END;
  END;
END;

PROCEDURE NewLine;
BEGIN
  Inc(Menu[MenuCount]^.ItemCount);
  WITH Menu[MenuCount]^ DO
  BEGIN
    New(ItemData[ItemCount]);
    WITH ItemData[ItemCount]^ DO
    BEGIN
      Name := NIL;
      Param := NIL;
      Disabled := True;
      KeyCode := 0;
    END;
  END;
END;
{-----------------------------------------------------------------}

{-----------------------------------------------------------------}
PROCEDURE DisposeMenu;
VAR I,R: Byte;
BEGIN
  FOR I := 1 TO MenuCount DO
  BEGIN
    DisposeStr(Menu[I]^.Name);
    FOR R := 1 TO Menu[I]^.ItemCount DO
    BEGIN
      IF Menu[I]^.ItemData[R]^.Name <> NIL THEN DisposeStr(Menu[I]^.ItemData[R]^.Name);
      IF Menu[I]^.ItemData[R]^.Param <> NIL THEN DisposeStr(Menu[I]^.ItemData[R]^.Param);
      Dispose(Menu[I]^.ItemData[R]);
    END;
    Dispose(Menu[I]);
  END;
END;
{-----------------------------------------------------------------}


{-----------------------------------------------------------------}
FUNCTION GetItem(Main,Sub: Byte): PMenuItem;
BEGIN
  GetItem := Menu[Main]^.ItemData[Sub];
END;

FUNCTION Disabled(Main,Sub: Byte): Boolean;
BEGIN
  Disabled := GetItem(Main,Sub)^.Disabled;
END;
{-----------------------------------------------------------------}


{-----------------------------------------------------------------}
PROCEDURE ModifyItemDisabled(Main,Sub: Byte; ADisabled: Boolean);
BEGIN
  Menu[Main]^.ItemData[Sub]^.Disabled := ADisabled;
END;

PROCEDURE ModifyItemParam(Main,Sub: Byte; NewParam: STRING);
BEGIN
  IF NewParam = '' THEN NewParam := ' ';
  IF Menu[Main]^.ItemData[Sub]^.Param <> NIL THEN
    DisposeStr( Menu[Main]^.ItemData[Sub]^.Param );
  Menu[Main]^.ItemData[Sub]^.Param := NewStr( NewParam );
END;
{-----------------------------------------------------------------}


{-----------------------------------------------------------------}
PROCEDURE DrawMenuBar;
VAR R: Byte;
BEGIN
  ClearLine(1,MenuPallette[NormalLineAttr]);
  FOR R := 1 TO MenuCount DO
  BEGIN
    WITH Menu[R]^ DO
    BEGIN
      FastWrite(MenuXPos-1,1,MenuPallette[NormalLineAttr],' '+Name^+' ');
      Attribute(MenuXPos,1,MenuPallette[NormalLineHiAttr],1);
    END;
  END;
END;

PROCEDURE DrawMenuItems(MenuNum: Byte);
LABEL Next,Exit;
VAR I,R,
    PL,NL,Attr,
    Width: Byte;
    TmpName: STRING;
    TmpParm: STRING;
    TmpItem: PMenuItem;
    ItemName: STRING;
BEGIN
  FOR I := 1 TO Menu[MenuNum]^.ItemCount DO
  BEGIN
    WITH GetItem(MenuNum,I)^ DO
    BEGIN
      Width := Menu[MenuNum]^.MenuWidth;
      TmpItem := GetItem(MenuNum,I);
      IF TmpItem^.Name = NIL THEN BEGIN ItemName := Replicate(Width+3,#196); GOTO Next; END;
      TmpName := Name^;
      IF Param <> NIL THEN TmpParm := Param^ ELSE TmpParm := '';
      NL := Length(TmpName);
      PL := Length(TmpParm);
      FOR R := NL TO Width - PL DO TmpName := TmpName + ' ';
      ItemName := TmpName + TmpParm;
    END;
Next:
    IF ItemName[1] <> #196 { Not equal to break line }
      THEN WITH Menu[MenuNum]^ DO
           BEGIN
             IF Disabled(MenuNum,I)
               THEN FastWrite(WinXPos,I+2,MenuPallette[DisNormAttr],' '+ItemName+' ')
               ELSE BEGIN
                      FastWrite(WinXPos,I+2,MenuPallette[NormalAttr],' '+ItemName+' ');
                      Attribute(WinXPos+ItemData[I]^.HiPos,I+2,MenuPallette[NormHiAttr],1);
                     END;
           END { WITH }
      ELSE WITH Menu[MenuNum]^ DO
           BEGIN
             FastWrite(WinXPos,I+2,MenuPallette[BoxAttr],ItemName);
           END;
  END;
  WITH Menu[MenuNum]^ DO
  BEGIN
    Attr := HiMenuBar;
    IF Disabled(MenuNum,Default) THEN Attr := DisHiAttr;
    Attribute(WinXPos,Default+2,MenuPallette[Attr],Menu[MenuNum]^.MenuWidth+3);
    IF Disabled(MenuNum,Default) THEN GOTO Exit;
    Attribute(WinXPos+GetItem(MenuNum,Default)^.HiPos,Default+2,MenuPallette[Attr+1],1);
    Exit:
    Attribute(MenuXPos-1,1,MenuPallette[HiMenuBar],Length(Menu[MenuNum]^.Name^)+2);
    Attribute(MenuXPos,1,MenuPallette[HiCMenuBar],1);
  END;
END;
{-----------------------------------------------------------------}


{-----------------------------------------------------------------}
FUNCTION RunMenu(MenuNum: Byte): ShortInt;
LABEL Quit;
VAR
  OK: Boolean;
  Key: Word;
  R,X,
  CPos,
  Items: Byte;

  PROCEDURE ShowBar(HiAttr: Boolean);
  LABEL Exit;
  VAR Attr: Byte;
  BEGIN
    Attr := NormalAttr;
    IF HiAttr THEN Inc(Attr,2);
    IF Disabled(MenuNum,CPos) THEN BEGIN Attr := DisNormAttr; IF HiAttr THEN Inc(Attr); END;
    Attribute(X,CPos+2,MenuPallette[Attr],Menu[MenuNum]^.MenuWidth+3);
    IF Disabled(MenuNum,CPos) THEN GOTO Exit;
    Attribute(X+GetItem(MenuNum,CPos)^.HiPos,CPos+2,MenuPallette[Attr+1],1);
    Exit:
  END;

BEGIN
  WITH Menu[MenuNum]^ DO
  BEGIN
    X := WinXPos;
    OK := False;
    CPos := Default;
    Items := ItemCount;
    MkWin(X-1,2,Menu[MenuNum]^.MenuWidth+4,ItemCount+1,MenuPallette[BoxAttr],MenuBorder,'');
    DrawMenuItems(MenuNum);
    REPEAT
      Key := GetKey;
      IF Key = kbF1 THEN HelpProcedure(MenuNum,CPos);
      ShowBar(False);
      CASE Key OF
          kbUp: IF CPos = 1 THEN CPos := ItemCount ELSE Dec(CPos);
        kbDown: IF CPos = ItemCount THEN CPos := 1 ELSE Inc(CPos);
       kbRight: BEGIN OK := True; RunMenu := cmRight; END;
        kbLeft: BEGIN OK := True; RunMenu := cmLeft; END;
        kbHome: CPos := 1;
         kbEnd: CPos := ItemCount;
         kbEsc: BEGIN OK := True; RunMenu := cmQuit; END;
       kbEnter: IF Disabled(MenuNum,CPos) = False THEN
                BEGIN
                  OK := True;
                  RunMenu := CPos;
                END;
         ELSE BEGIN
                FOR R := 1 TO ItemCount DO
                BEGIN
                  IF (Key < 123) AND (Key > 96) THEN Dec(Key,32);
                  IF (UpCase(ItemData[R]^.HiChar) = Chr(Key)) OR (ItemData[R]^.KeyCode = Key) THEN
                    IF Disabled(MenuNum,R) = False THEN
                    BEGIN
                      OK := True;
                      CPos := R;
                      RunMenu := R;
                      Break;
                    END;
                END; { IF }
                FOR R := 1 TO MenuCount DO
                 IF Menu[R]^.KeyCode = Key THEN
                 BEGIN
                    OK := True;
                    RunMenu := R + 100;
                  END; { IF }
              END; { ELSE }
      END; { CASE }
      IF (ItemData[CPos]^.Name = NIL) AND (Key = kbDown) THEN Inc(CPos);
      IF (ItemData[CPos]^.Name = NIL) AND (Key = kbUp) THEN Dec(CPos);
Quit: ShowBar(True);
      Default := CPos;
    UNTIL OK;
    RmWin;
    DrawMenuBar;
  END; { WITH }
END;
{-----------------------------------------------------------------}


{-----------------------------------------------------------------}
PROCEDURE MenuHandle(VAR Key: Word);
VAR
  R: Byte;
  OK: Boolean;
  Main: Byte;
  Event: ShortInt;
BEGIN
  OK := False;
  Main := 0;
  FOR R := 1 TO MenuCount DO
    IF Menu[R]^.KeyCode = Key THEN
    BEGIN
      Main := R;
      Break;
    END;
  IF Key = kbF10 THEN BEGIN Key := 0; Main := LastOpened; END;
  IF Main = 0 THEN Exit;
  REPEAT
    Event := RunMenu(Main);
    CASE Event OF
    101..120: Main := Event - 100;
       1..20: BEGIN
                IF GetItem(Main,Event)^.KeyCode <> 0
                  THEN Key := GetItem(Main,Event)^.KeyCode;
                MenuDispacher(Main,Event);
                OK := True;
              END;
     cmRight: IF Main = MenuCount THEN Main := 1 ELSE Inc(Main);
      cmLeft: IF Main = 1 THEN Main := MenuCount ELSE Dec(Main);
      cmQuit: OK := True;
     END;
     LastOpened := Main;
  UNTIL OK;
END;
{-----------------------------------------------------------------}

PROCEDURE Empty(Main,Sub: Byte);
BEGIN
END;

PROCEDURE InitGMenus;
BEGIN
  MenuCount                      := 0;
  LastOpened                     := 1;
  MenuBorder                     := Single1;
  MenuDispacher                  := Empty;
  HelpProcedure                  := Empty;
  MenuPallette[NormalLineAttr  ] := $07;
  MenuPallette[NormalLineHiAttr] := $0F;
  MenuPallette[NormalAttr      ] := $57;
  MenuPallette[NormHiAttr      ] := $5F;
  MenuPallette[HiMenuBar       ] := $20;
  MenuPallette[HiCMenuBar      ] := $2F;
  MenuPallette[DisNormAttr     ] := $58;
  MenuPallette[DisHiAttr       ] := $28;
  MenuPallette[BoxAttr         ] := $5D;
END;

BEGIN
  InitGMenus;
END.
